; ===============================================================
; Buchstaben suchen
; Eingang:	CmdPos		Cmd-Position
; Ausgang:	W & CmdByte	Ascii-Buchstabe A...Z
;		F_OK		0=kein Buchstabe / 1=Buchstabe gefunden
;		F_CmdE		1=Cmd-Puffer zu Ende
; ===============================================================
p1SuchA_Z	bcf	F_OK		; Erst mal nix gefunden
p1SuchA_Z_1	call	p1GetCmdByte	; Cmd-Byte aus Cmd-Puffer laden
		skip_0	F_CmdE		; ... Cmd-Puffer noch nicht zu Ende
		retlw	0x0FF

		movfw	CmdByte		; Cmd-Byte zurueck
		sublw	"?"		; = "?"
		skip_NZ			; ... nein
		goto	p1SuchA_Z__	; ... ja: Cmd gefunden

		movfw	CmdByte		; Cmd-Byte zurueck
		sublw	"A"-1		; > "A"-1
		skip_NC			; ... ja
		goto	p1SuchA_Z_1	; ... nein: Naechster

		movfw	CmdByte		; Cmd-Byte zurueck
		sublw	"Z"		; > "Z"
		skip_NC			; ... ja
		goto	p1SuchA_Z_Ok	; ... nein: A...Z

		movfw	CmdByte		; Cmd-Byte zurueck
		sublw	"a"-1		; > "a"-1
		skip_NC			; ... ja
		goto	p1SuchA_Z_1	; ... nein: Naechster

		movfw	CmdByte		; Cmd-Byte zurueck
		sublw	"z"		; > "z"
		skip_C			; ... nein
		goto	p1SuchA_Z_1	; ... ja: Naechster

p1SuchA_Z_Ok	movfw	CmdByte		; Cmd-Byte zurueck
		andlw	01011111b	; Klein nach Gross
		movwf	CmdByte
p1SuchA_Z__	bsf	F_OK		; OK
		return

; ===============================================================
; Ziffer suchen (0...65535)
; Eingang:	CmdPos		Cmd-Position
; Ausgang:	MathErg0 & W	; Wert Low
;		MathErg1	; Wert High
;		F_OK		0=keine Ziffern / 1=Ziffern gefunden
;		F_CmdE		1=Cmd-Puffer zu Ende
;		F_Word		0=Byte (< 256) / 1=Word (> 255)
; ===============================================================
p1Such0_9	bcf	F_OK		; Erst mal nix gefunden
		bcf	F_Word		; Erst mal < 256
		clrf	MathErg0	; Wert erst mal 0
		clrf	MathErg1

		; ---------------------------
		; 1. Ziffer suchen
		; ---------------------------
p1Such0_9_1	call	p1GetCmdByte	; Cmd-Byte aus Cmd-Puffer laden
		skip_0	F_CmdE		; ... Cmd-Puffer noch nicht zu Ende
		return

		movfw	CmdByte
		sublw	"0"-1		; > "0"-1
		skip_NC			; ... ja
		goto	p1Such0_9_1	; ... nein: Naechster

		movfw	CmdByte
		sublw	"9"		; > "9"
		skip_C			; ... nein
		goto	p1Such0_9_1	; ... ja: Naechster

p1Such0_9_2	movlw	"0"		; F - W
		subwf	CmdByte,W	; Ascii nach Bin
		addwf	MathErg0	; Bisheriger Wert + neuer Wert
		skip_C			; ... bertrag
		goto	p1Such0_9_3	; ... kein bertrag

		incf	MathErg1	; High-Byte + 1
		skip_NZ			; ... kein bertrag
		goto	p1Such0_9_Nok	; Wert zu gross

		; ---------------------------
		; Naechste Ziffer suchen
		; ---------------------------
p1Such0_9_3	call	p1GetCmdByte	; Cmd-Byte aus Cmd-Puffer laden
		skip_0	F_CmdE		; ... Cmd-Puffer noch nicht zu Ende
		goto	p1Such0_9_Ok	; ... ja: Ende

		movfw	CmdByte
		sublw	"."		; = Punkt ?
		skip_NZ			; ... nein
		goto	p1Such0_9_3	; ... ja: Naechster

	;;	movfw	CmdByte
	;;	sublw	":"		; = DoppelPunkt ?
	;;	skip_NZ			; ... nein
	;;	goto	p1Such0_9_3	; ... ja: Naechster

		movfw	CmdByte
		sublw	"0"-1		; > "0"-1
		skip_NC			; ... ja
		goto	p1Such0_9_Ok	; ... nein: Ende

		movfw	CmdByte
		sublw	"9"		; > "9"
		skip_C			; ... nein
		goto	p1Such0_9_Ok	; ... ja

		; ---------------------------
		; Bisheriger Wert * 10
		; Neuen Wert addieren
		; ---------------------------
		call	p1Mulu1610_x	; Bisheriger Wert * 10
		skip_1	F_Ovfl		; ... berlauf
		goto	p1Such0_9_2

		goto	p1Such0_9_Nok	; Wert zu gross

p1Such0_9_Ok	bsf	F_OK		; OK
		movfw	MathErg1	; > 255 ?
		skip_Z			; ... nein
		goto	p1Such0_9_Word

		movfw	MathErg0	; Ergebnis Low nach W
		return

p1Such0_9_Word	bsf	F_Word		; ... ja
p1Such0_9_Nok	movlw	255
		movwf	MathErg0
		return

; ===============================================================
; Byte aus Cmd-Puffer laden
; Eingang:	CmdPos		Cmd-Position
; Ausgang:	CmdByte		Byte
;		F_CmdE		1=Cmd-Puffer Ende
; Benutzt:	FSR,	INDF
; ===============================================================
p1GetCmdByte	bsf	F_CmdE		; Puffer erst mal zu Ende
		movfw	CmdPos
		sublw	CmdLen-1	; CmdPos > CmdLen-1 ?
		skip_C			; ... nein
		retlw	0x0FF

		movlw	LOW(CmdPuf)	; Cmd-Puffer-Adresse
		addwf	CmdPos,W	; plus Offset
		movwf	FSR		; fuer indirekte Adressierung
		bsf	STATUS,IRP	; Bank 2 / 3
		movfw	INDF		; Cmd-Byte laden
		movwf	CmdByte		; und retten
		skip_NZ			; ... Cmd-Byte <> 0: kein Cmd-Ende
		retlw	0x0FF

		bcf	F_CmdE		; Puffer nicht zu Ende
		incf	CmdPos		; Offset + 1
		return

; ===============================================================
; Byte aus RxD-Puffer laden
; Eingang:	RxDPos		RxD-Position
; Ausgang:	CmdByte		Byte
;		RxDPos		+ 1 oder 0
; Benutzt:	FSR,	INDF
; ===============================================================
p1GetRxDByte	movlw	LOW(RxDPuf)	; RxD-Puffer-Adresse
		addwf	RxDPos,W	; plus Offset
		movwf	FSR		; fuer indirekte Adressierung
		bsf	STATUS,IRP	; Bank 2 / 3
		movfw	INDF		; Byte aus RxD-Puffer laden
		movwf	CmdByte		; und retten
		incf	RxDPos		; Offset + 1
		movfw	RxDPos
		sublw	RxDLen-1	; RxDPos > RxDLen-1 ?
		skip_C			; ... nein
		clrf	RxDPos		; ... ja: Offset = 0

		return

; ===============================================================
; Diverse Zeichen senden
; ===============================================================
p1PrnSpc99	movlw	" "		; Leerzeichen senden
		call	p1PrnChr
		movlw	"9"		; 9 senden
		call	p1PrnChr
		movlw	"9"		; 9 senden
		call	p1PrnChr
		movlw	" "		; Leerzeichen senden
		goto	p1PrnChr

p1PrnCrLf	movlw	0x0D		; CR
		call	p1PrnChr
		movlw	0x0A		; LF
		goto	p1PrnChr

; ---------------------------
; Ziffern-Ausgabe in Ascii
; ---------------------------
p1PrnZif0_9	bsf	F_Zif		; 1...9 gesendet
		addlw	"0"		; + Ascii-0
		goto	p1PrnChr	; Ziffer senden

; ---------------------------
; Ziffern-Ausgabe formatiert / unformatiert
; ---------------------------
p1FmtZif	addlw	0		; Wert = 0 ?
		skip_Z			; ... ja
		goto	p1PrnZif0_9	; ... sonst Ziffer senden

		skip_0	F_000		; ... keine fuehrende Nullen senden
		goto	p1PrnZif0_9	; ... sonst Ziffer senden

		skip_0	F_Zif		; ... noch keine Ziffer gesendet
		goto	p1PrnZif0_9	; ... sonst Ziffer senden

p1FmtSpc	skip_1	F_Fmt		; ... Leerzeichen senden
		return			; ... sonst nix senden

p1PrnSpc	movlw	" "		; Leerzeichen
		goto	p1PrnChr
; ---------------------------

p1PrnZifP	movlw	"."		; Punkt oder Komma
		goto	p1PrnChr

p1PrnPkt	movlw	"."		; Punkt
		goto	p1PrnChr

p1PrnKomma	movlw	","		; Komma
		goto	p1PrnChr

p1PrnDpkt	movlw	":"		; DoppelPunkt
		goto	p1PrnChr

p1PrnSemi	movlw	";"		; Semikolon
		goto	p1PrnChr

p1PrnStern	movlw	"*"		; Stern
		goto	p1PrnChr

p1PrnSKauf	movlw	"<"		; Spitze Klammer auf
		goto	p1PrnChr

p1PrnSKzu	movlw	">"		; Spitze Klammer zu
		goto	p1PrnChr

p1PrnGKauf	movlw	"("		; Geschw. Klammer auf
		goto	p1PrnChr

p1PrnGKzu	movlw	")"		; Geschw. Klammer zu
		goto	p1PrnChr

; ===============================================================
; Charakter (Byte) senden (im TxD-Puffer ablegen)
; Eingang:	W	Charakter (Byte)
; Ausgang:	TxDPos + 1 oder 0
;		TxDAnz + 1
; Benutzt:	MathTmp1,	FSR,	INDF
; ===============================================================
p1PrnChr	movwf	MathTmp1	; Byte retten
p1PrnChr_1	movfw	TxDAnz		; TxD-Puffer voll ?
		sublw	TxDLen-4	; TxDAnz > TxDLen-4 ?
		skip_C			; ... nein
		goto	p1PrnChr_1	; ... sonst warten

		incf	TxDAnz		; Anzahl TxD + 1
		movlw	LOW(TxDPuf)	; Puffer-Adresse
		addwf	TxDPos,W	; plus Offset
		movwf	FSR		; fuer indirekte Adressierung
		bsf	STATUS,IRP	; Bank 2 / 3
		movfw	MathTmp1	; Byte zurueck
		movwf	INDF		; und im Ringpuffer speichern
		incf	TxDPos		; Offset + 1
		movfw	TxDPos
		sublw	TxDLen-1	; TxDPos > TxDLen-1 ?
		skip_C			; ... nein
		clrf	TxDPos		; ... ja: Offset = 0

		return

; ===============================================================
; Commando-Puffer anzeigen
; ===============================================================
p1PrnCmd	call	p1PrnCrLf
		movlw	"<"
		call	p1PrnChr
		clrf	Para1
p1PrnCmd_1	movlw	LOW(CmdPuf)	; Puffer-Adresse
		addwf	Para1,W
		movwf	FSR		; fuer indirekte Adressierung
		bsf	STATUS,IRP	; Bank 2 / 3
		movfw	INDF		; Byte laden
		skip_NZ
		goto	p1PrnCmd_2

		call	p1PrnAsc
		incf	Para1
		goto	p1PrnCmd_1

p1PrnCmd_2	movlw	">"
		call	p1PrnChr
		goto	p1PrnSpc

; ===============================================================
; Byte als Ascii- oder Hex-Zeichen senden (im TxD-Puffer ablegen)
; Eingang:	W	Charakter (Byte)
; Ausgang:	TxDPos + 1 oder 0
;		TxDAnz + 1
; Benutzt:	MathTmp0,	FSR,	INDF
; ===============================================================
p1PrnAsc	movwf	MathTmp0	; Byte retten
		addlw	0xE0		; >= 20h ?
		skip_C			; ... ja
		goto	NoAscii

		movfw	MathTmp0
		addlw	0x80		; >= 80h ?
		skip_C			; ... ja
		goto	IfAscii

NoAscii		movlw	"<"
		call	p1PrnChr
		movfw	MathTmp0
		call	p1PrnZifH
		movlw	">"
		goto	p1PrnChr

IfAscii		movfw	MathTmp0
		goto	p1PrnChr

; ===============================================================
; String aus FlashSpeicher senden
; Eingang:	AddrL		FlashAdresse Low
;		AddrH		FlashAdresse High
; ===============================================================
p1PrnStrF	call	p1RdFlash	; Byte aus FlashSpeicher lesen
		incf	AddrL		; Addresse + 1
		skip_NZ
		incf	AddrH

		movfw	EepByte
		skip_NZ			; ... kein StringEnde
		return

		call	p1PrnChr	; Byte senden
		goto	p1PrnStrF

; ===============================================================
; Ziffer 1-stellig dezimal senden
; Eingang:	W	Byte 0...9
; Wenn Byte > 9 ist, dann wird 1 Stern gesendet
; ===============================================================
p1PrnZif1	bcf	F_Pkt
		bcf	F_Pkt2
p1PrnZif1X	movwf	MathArgA0	; Byte retten
		call	p1Divu0810	; MathArgA0 / 10
		movfw	MathErg1	; 100-er = 0 ?
		skip_Z			; ... ja
		goto	p1PrnStern	; ... nein: 1 Stern senden

		movfw	MathErg0	; 10-er = 0 ?
		skip_NZ			; ... nein: 1 Stern senden
		goto	p1PrnZif3_2	; ... ja

		goto	p1PrnStern

; ===============================================================
; Ziffer 2-stellig dezimal senden
; Eingang:	W	Byte 0...99
; Wenn Byte > 99 ist, dann werden 2 Sterne gesendet
; ===============================================================
p1PrnZif21	bsf	F_Pkt
		bcf	F_Pkt2
		goto	p1PrnZif2X

p1PrnZif2	bcf	F_Pkt
		bcf	F_Pkt2
p1PrnZif2X	movwf	MathArgA0	; Byte retten
		call	p1Divu0810	; MathArgA0 / 10
		bcf	F_Zif		; Erst mal keine 1...9 gesendet
		movfw	MathErg1	; 100-er = 0 ?
		skip_NZ			; ... nein: 2 Sterne senden
		goto	p1PrnZif3_1	; ... ja

		call	p1PrnStern
		skip_0	F_Pkt
		call	p1PrnZifP	; Punkt senden
		goto	p1PrnStern

; ===============================================================
; Mehrere Werte 3-stellig dezimal senden, ohne Nachkommastelle
; Eingang:	zUni	Anzahl Werte
;		Para1	Adresse in Bank 0 / 1
; ===============================================================
p1PrnWerte30	call	p1PrnSpc	; Leerzeichen senden
		movfw	Para1		; Speicher-Adresse laden
		movwf	FSR		; fuer indirekte Adressierung
		bcf	STATUS,IRP	; Bank 0 / 1
		movfw	INDF		; Wert laden
		call	p1PrnZif30	; und senden
		incf	Para1		; Adr + 1
		decfsz	zUni		; Zaehler - 1
		goto	p1PrnWerte30

		return

; ===============================================================
; Mehrere Werte 3-stellig dezimal senden, mit 1 Nachkommastelle
; Eingang:	zUni	Anzahl Werte
;		Para1	Adresse in Bank 0 / 1
; ===============================================================
p1PrnWerte31	call	p1PrnSpc	; Leerzeichen senden
		movfw	Para1		; Speicher-Adresse laden
		movwf	FSR		; fuer indirekte Adressierung
		bcf	STATUS,IRP	; Bank 0 / 1
		movfw	INDF		; Wert laden
		call	p1PrnZif31	; und senden
		incf	Para1		; Adr + 1
		decfsz	zUni		; Zaehler - 1
		goto	p1PrnWerte31

		return

; ===============================================================
; Mehrere Werte 3-stellig dezimal senden, mit 2 Nachkommastellen
; Eingang:	zUni	Anzahl Werte
;		Para1	Adresse in Bank 0 / 1
; ===============================================================
p1PrnWerte32	call	p1PrnSpc	; Leerzeichen senden
		movfw	Para1		; Speicher-Adresse laden
		movwf	FSR		; fuer indirekte Adressierung
		bcf	STATUS,IRP	; Bank 0 / 1
		movfw	INDF		; Wert laden
		call	p1PrnZif32	; und senden
		incf	Para1		; Adr + 1
		decfsz	zUni		; Zaehler - 1
		goto	p1PrnWerte32

		return

; ===============================================================
; Ziffer 3-stellig dezimal senden, mit 0, 1 oder 2 Nachkommastellen
; Eingang:	W	Byte 0...255
; ===============================================================
p1PrnZif32	bsf	F_Pkt2
		bcf	F_Pkt
		goto	p1PrnZif3X

p1PrnZif31	bsf	F_Pkt
		bcf	F_Pkt2
		goto	p1PrnZif3X

p1PrnZif30	bcf	F_Pkt
		bcf	F_Pkt2
p1PrnZif3X	movwf	MathArgA0	; Byte retten
		call	p1Divu0810	; MathArgA0 / 10
		bcf	F_Zif		; Erst mal keine 1...9 gesendet
		skip_0	F_Pkt2
		bsf	F_Zif		; Vor dem Punkt 0 senden

		movfw	MathErg1	; 100-er evtl. senden
		call	p1FmtZif
		skip_0	F_Pkt2
		call	p1PrnZifP	; Punkt senden

		skip_0	F_Pkt
		bsf	F_Zif		; Vor dem Punkt 0 senden

p1PrnZif3_1	movfw	MathErg0	; 10-er evtl. senden
		call	p1FmtZif
		skip_0	F_Pkt
		call	p1PrnZifP	; Punkt senden

p1PrnZif3_2	movfw	MathArgA0	; 1-er senden
		goto	p1PrnZif0_9

; ===============================================================
; Ziffer hexadezimal senden
; Eingang:	W		Byte 0...255
; ===============================================================
p1PrnZifH	movwf	MathArgA0	; Byte retten
		movlw	"0"		; "0" senden
		call	p1PrnChr
		movlw	"x"		; "x" senden
		call	p1PrnChr
		swapf	MathArgA0,W	; HighNibbl laden
		andlw	00001111b	; Bit 3...0 maskieren
		addlw	"0"		; = AsciiHighNibbl
		movwf	MathArgA1	; und retten
		sublw	"9"		; > "9" ?
		skip_NC			; ... ja
		goto	p1PrnZifH_1

		movfw	MathArgA1	; AsciiHighNibbl zurueck
		movlw	7		; A...F
		addwf	MathArgA1	; und retten
p1PrnZifH_1	movfw	MathArgA1	; AsciiHighNibbl senden
		call	p1PrnChr
		movfw	MathArgA0	; LowNibbl laden
		andlw	00001111b	; Bit 3...0 maskieren
		addlw	"0"		; = AsciiLowNibbl
		movwf	MathArgA1	; und retten
		sublw	"9"		; > "9" ?
		skip_NC			; ... ja
		goto	p1PrnZifH_2

		movfw	MathArgA1	; AsciiLowNibbl zurueck
		movlw	7		; A...F
		addwf	MathArgA1	; und retten
p1PrnZifH_2	movfw	MathArgA1	; AsciiLowNibbl senden
		goto	p1PrnChr

; *****************************************************************
; 16 Bit Multiplikation mit 10d
; Eingang:	MathArgA1..0	Multiplikant
; Ausgang:	MathErg1..0	Multiplikant * 10
;		F_Ovfl		0 = Wert ist OK
;				1 = berlauf (> 65535)
; *****************************************************************
p1Mulu1610_x	movfw	MathErg0
		movwf	MathArgA0
		movfw	MathErg1
		movwf	MathArgA1

p1Mulu1610	bsf	F_Ovfl		; Erst mal berlauf
		movfw	MathArgA0
		movwf	MathErg0
		movfw	MathArgA1
		movwf	MathErg1
		bcf	_C		; C=0
		rlf	MathErg0	; Multiplikant * 2
		rlf	MathErg1
		skip_NC
		return			; ... Wert zu gross

		movfw	MathErg0
		movwf	MathTmp0
		movfw	MathErg1
		movwf	MathTmp1
		bcf	_C		; C=0
		rlf	MathErg0	; * 4
		rlf	MathErg1
		skip_NC
		return			; ... Wert zu gross

		rlf	MathErg0	; * 8
		rlf	MathErg1
		skip_NC
		return			; ... Wert zu gross

		movfw	MathTmp0	; *8 + *2 = *10
		addwf	MathErg0
		skip_C			; ... Uebertrag
		goto	p1Mulu1610_1	; ... kein Uebertrag

		incf	MathErg1
		skip_NZ
		return			; ... Wert zu gross

p1Mulu1610_1	movfw	MathTmp1
		addwf	MathErg1
		skip_NC
		return			; ... Wert zu gross

		bcf	F_Ovfl		; Kein berlauf
		return

; *****************************************************************
; 8 Bit Division durch 10d
; Eingang:	MathArgA0
; Ausgang:	MathErg1	Ergebnis 100-er
;		MathErg0	Ergebnis 10-er
;		MathArgA0	Rest (1-er)
; *****************************************************************
p1Divu0810	movlw	255
		movwf	MathErg0	; Ergebnis  10-er = 255
		movwf	MathErg1	; Ergebnis 100-er = 255

		movlw	100
p1Divu0810_1	incf	MathErg1	; Ergebnis 100-er + 1
		bcf	_C		; Carry = 0
		subwf	MathArgA0	; Divident - 100
		btfsc	_C		; ... Unterlauf
		goto	p1Divu0810_1

		addwf	MathArgA0	; Rest 10-er
		movlw	10
p1Divu0810_2	incf	MathErg0	; Ergebnis 10-er + 1
		bcf	_C		; Carry = 0
		subwf	MathArgA0	; Divident - 10
		btfsc	_C		; ... Unterlauf
		goto	p1Divu0810_2

		addwf	MathArgA0	; Rest 1-er
		return

; ***************************************************************
; EEPROM- und FLASH-ROUTINEN
; ***************************************************************
; ---------------------------------------------------------------
; Konfiguration aus Eeprom in Ram kopieren
; ---------------------------------------------------------------
p1EepToRam	movlw	AnzParam1	; n Param
		movwf	zUni
		movlw	LOW(EepParam1)	; Eep-Adr setzen
		movwf	AddrL
		movlw	LOW(RamParam1)	; Ram-Adr setzen
		movwf	FSR
		bcf	STATUS,IRP	; Bank 0 / 1

p1EepToRam_1	call	p1RdEeprom	; Eeprom lesen
		movwf	INDF		; Byte speichern
		incf	AddrL		; Eep-Adr + 1
		incf	FSR		; Ram-Adr + 1
		decfsz	zUni		; ... Zlr - 1 = 0
		goto	p1EepToRam_1

		movlw	AnzParam2	; n Param
		movwf	zUni
		movlw	LOW(EepParam2)	; Eep-Adr setzen
		movwf	AddrL
		movlw	LOW(RamParam2)	; Ram-Adr setzen
		movwf	FSR
		bcf	STATUS,IRP	; Bank 0 / 1

p1EepToRam_2	call	p1RdEeprom	; Eeprom lesen
		movwf	INDF		; Byte speichern
		incf	AddrL		; Eep-Adr + 1
		incf	FSR		; Ram-Adr + 1
		decfsz	zUni		; ... Zlr - 1 = 0
		goto	p1EepToRam_2

		return

; ---------------------------------------------------------------
; Konfiguration aus Ram in Eeprom kopieren
; ---------------------------------------------------------------
p1RamToEep	movlw	AnzParam1	; n Param
		movwf	zUni
		movlw	LOW(EepParam1)	; Eep-Adr setzen
		movwf	AddrL
		movlw	LOW(RamParam1)	; Ram-Adr setzen
		movwf	FSR
		bcf	STATUS,IRP	; Bank 0 / 1

p1RamToEep_1	movfw	INDF		; Byte laden
		call	p1WrEeprom	; Eeprom schreiben
		incf	AddrL		; Eep-Adr + 1
		incf	FSR		; Ram-Adr + 1
		decfsz	zUni		; ... Zlr - 1 = 0
		goto	p1RamToEep_1

		return

; ---------------------------------------------------------------
; Byte aus Eeprom lesen
; Eingang:	AddrL		Eeprom-Adresse Low
; Ausgang:	W & EepByte	Daten-Byte
; ---------------------------------------------------------------
p1RdEeprom	M_movlf	10,t10ms	; 50 * 10 ms TimeOut-Zeit
p1RdEeprom_1	M_Bank0			; Bank 0
		movfw	t10ms		; TimeOut ?
		skip_NZ			; ... nein
		goto	p1EepErrRd	; ... sonst: Fehler

		bsf	STATUS,RP0	; Bank 3
		bsf	STATUS,RP1
		skip_0	EECON1,WR	; ... letzter Schreibvorgang ist fertig
		goto	p1RdEeprom_1	; ... sonst warten

		bcf	STATUS,RP0	; Bank 2
		clrf	EEADRH		; Eeprom-Adr High = 0
		M_movff	AddrL,EEADR	; AddrL speichern
		bsf	STATUS,RP0	; Bank 3
		bcf	EECON1,EEPGD	; Zugriff auf Eeprom
		bsf	EECON1,RD	; Lesezugriff freigeben
		bcf	STATUS,RP0	; Bank 2
		M_movff	EEDATA,EepByte	; Byte aus Eeprom nach EepByte
		M_Bank0			; Bank 0
		movfw	EepByte		; Daten-Byte nach W
		return

; ---------------------------------------------------------------
; Byte in Eeprom schreiben (ohne Verify)
; Eingang:	W		Daten-Byte
;		AddrL		Eeprom-Adresse
; Ausgang:	Daten-Byte im Eeprom
; ---------------------------------------------------------------
p1WrEeprom	movwf	EepByte		; Daten-Byte nach EepByte
		M_movlf	10,t10ms	; 50 * 10 ms TimeOut-Zeit

p1WrEeprom_1	M_Bank0			; Bank 0
		movfw	t10ms		; TimeOut ?
		skip_NZ			; ... nein
		goto	p1EepErrWr	; ... sonst: Fehler

		bsf	STATUS,RP0	; Bank 3
		bsf	STATUS,RP1
		skip_0	EECON1,WR	; ... letzter Schreibvorgang ist fertig
		goto	p1WrEeprom_1	; ... sonst warten

		bcf	STATUS,RP0	; Bank 2
		M_movff	AddrL,EEADR	; Eeprom-Adresse in EEADR ablegen
		clrf	EEADRH		; Eeprom-Adr High-Byte = 0

		; ---------------------------
		; Byte aus Eeprom lesen und mit neuem Byte vergleichen.
		; Wenn Eeprom-Byte und Neues Byte gleich sind,
		; ist kein Schreibvorgang erforderlich.
		; ---------------------------
		bsf	STATUS,RP0	; Bank 3
		bcf	EECON1,EEPGD	; Zugriff auf Eeprom
		bsf	EECON1,RD	; Lesezugriff freigeben
		bcf	STATUS,RP0	; Bank 2
		movfw	EEDATA		; Byte aus Eeprom nach W-Register
		bcf	STATUS,RP1	; Bank 0
		subwf	EepByte,W	; Eeprom-Byte = neues Byte ?
		skip_NZ			; ... nein
		return			; ... sonst kein Schreibvorgang

		; ---------------------------
		; Eeprom-Byte <> neues Byte:
		; Schreibvorgang starten
		; ---------------------------
		movfw	EepByte		; Byte zurueck
		bsf	STATUS,RP1	; Bank 2
		movwf	EEDATA		; Byte in Eeprom-Data ablegen
		bsf	STATUS,RP0	; Bank 3
		bcf	EECON1,EEPGD	; Zugriff auf Eeprom
		bsf	EECON1,WREN	; Schreibzugriff freigeben
		bcf	INTCON,GIE	; Globaler Int aus
		M_movlf	0x55,EECON2	; SchreibZyklus initialisieren
		M_movlf	0xAA,EECON2
		bsf	EECON1,WR	; Schreibzugriff beginnen
		nop
		bsf	INTCON,GIE	; Globaler Int wieder ein
		bcf	EECON1,WREN	; Schreibzugriff sperren
		M_Bank0			; Bank 0
		return

p1EepErrRd	clrf	EepByte
p1EepErrWr	movlw	7		; Eeprom TimeOut
		movlw	LOW(TxtSysErr_7); Kalt-Start
		movwf	AddrL
		movlw	HIGH(TxtSysErr_7)
		movwf	AddrH
		call	p1PrnStrF	; String senden
		call	p1PrnCrLf	; cr/lf senden
		return

; ---------------------------------------------------------------
; Byte aus FlashSpeicher lesen
; Eingang:	AddrL		FlashAdresse Low
;		AddrH		FlashAdresse High
; Ausgang:	W & EepByte	Daten-Byte
; ---------------------------------------------------------------
p1RdFlash	M_movlf	10,t10ms	; 50 * 10 ms TimeOut-Zeit
p1RdFlash_1	M_Bank0			; Bank 0
		movfw	t10ms		; TimeOut ?
		skip_NZ			; ... nein
		goto	p1EepErrRd	; ... sonst: Fehler

		bsf	STATUS,RP0	; Bank 3
		bsf	STATUS,RP1
		skip_0	EECON1,WR	; ... letzter Schreibvorgang ist fertig
		goto	p1RdFlash_1	; ... sonst warten

		bcf	STATUS,RP0	; Bank 2
		M_movff	AddrH,EEADRH	; AddrH speichern
		M_movff	AddrL,EEADR	; AddrL speichern
		bsf	STATUS,RP0	; Bank 3
		bsf	EECON1,EEPGD	; Zugriff auf FlashSpeicher
		bsf	EECON1,RD	; Flash lesen
		nop
		nop
		bcf	STATUS,RP0	; Bank 2
		M_movff	EEDATA,EepByte	; Byte in EepByte speichern
			; EEDATH wird nicht benutzt
		M_Bank0			; Bank 0
		movfw	EepByte		; Daten-Byte nach W
		return
